//+------------------------------------------------------------------+
//|                                                  BreakoutTTM.mq4 |
//|                                                            Dasio |
//|                                                            Dasio |
//+------------------------------------------------------------------+
#property copyright "Dasio"
#property link      "Dasio"

extern int MagicNumber =13579;
extern int MargineSL=50;
extern int Slippage=2;
extern double Rischio_per_trade =0.5;

datetime Time_0;
double p1,p2,Pendente_Buy,Pendente_Sell;
datetime b1,b2;
double MyLots,AllowedLots,MaxLots,MinLot,StopValue,TickValue; 
int RightLots;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
  Time_0 = Time[0]; 
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
 string symbol=Symbol();
if (Time_0 != Time[0])                                  
      {
                                          
      Time_0 = Time[0]; 

                  if(OTBM(MagicNumber)==0)
                           {
                                    if(iClose(NULL,0,1)>PendenteBuy()) ApriLong(symbol);
                                    if(iClose(NULL,0,1)<PendenteSell()) ApriShort(symbol);
                                    
                      else
                   if(CalculateCurrentBuy(MagicNumber)>=1) TrailingBuy(PendenteSell(),symbol);
                   if(CalculateCurrentSell(MagicNumber)>=1) TrailingSell(PendenteBuy(),symbol);}
                           

}
   return(0);
  }
//+------------------------------------------------------------------+

int OTBM(int intMagic)//OrdersTotalByMagic
{
int intCount=0;
int intPOS=0;
bool boolTerm=false;
while(boolTerm==false)
{
if(OrderSelect(intPOS,SELECT_BY_POS))
{
if(OrderMagicNumber()==intMagic) intCount++;
intPOS++;
}
else
boolTerm=true;
}
return(intCount);
}  

//find the level for last high swing
double PendenteBuy(){
double temp = 0;
   int count =0;
   for(int i = 3 ; i < 1500 ; i++) {
 temp = iCustom(NULL,0,"TTM scalper",0,i);
  if (temp != EMPTY_VALUE) count = count+1;
 if(count == 1 && temp != EMPTY_VALUE) {p1=NormalizeDouble(temp,4);b1=Time[i];}
   if(count == 2 && temp != EMPTY_VALUE) {p2=NormalizeDouble(temp,4);b2=Time[i];}
    if(count == 3) break;
   } 
  //Set shift Indicator signal   
int a =iBarShift(Symbol(),0,b1);  
     int b =iBarShift(Symbol(),0,b2);  
                                                      
    double  h1=NormalizeDouble(iHigh(Symbol(),0,a),4);
    double    h2=NormalizeDouble(iHigh(Symbol(),0,b),4);
    double    l1=NormalizeDouble(iLow(Symbol(),0,a),4); 
    double  l2=NormalizeDouble(iLow(Symbol(),0,b),4); 
                   
    if(p1==h1){ Pendente_Buy=NormalizeDouble(h1,5);}
    else{if(p1==l1){Pendente_Buy=NormalizeDouble(h2,5);}
                                                    
}
return(Pendente_Buy);
}

//find the level for the last low swing
double PendenteSell(){
double temp = 0;
   int count =0;
   for(int i = 3 ; i < 1500 ; i++) {
 temp = iCustom(NULL,0,"TTM scalper",0,i);
  if (temp != EMPTY_VALUE) count = count+1;
 if(count == 1 && temp != EMPTY_VALUE) {p1=NormalizeDouble(temp,4);b1=Time[i];}
   if(count == 2 && temp != EMPTY_VALUE) {p2=NormalizeDouble(temp,4);b2=Time[i];}
    if(count == 3) break;
   } 
  //Set shift Indicator signal   
int a =iBarShift(Symbol(),0,b1);  
     int b =iBarShift(Symbol(),0,b2);  
                                                      
    double  h1=NormalizeDouble(iHigh(Symbol(),0,a),4);
    double    h2=NormalizeDouble(iHigh(Symbol(),0,b),4);
    double    l1=NormalizeDouble(iLow(Symbol(),0,a),4); 
    double  l2=NormalizeDouble(iLow(Symbol(),0,b),4); 
                   
    if(p1==l1){ Pendente_Sell=NormalizeDouble(l1,5);}
    else{if(p1==h1){Pendente_Sell=NormalizeDouble(l2,5);}
                                                    
}
return(Pendente_Sell);
}



int CalculateCurrentBuy(int Magic) { 
   int buys=0;
//---- 
   for(int i=0;i<OrdersTotal();i++) { 
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false ) break; 
      if(OrderSymbol()==Symbol()) { 
         if(OrderType()==OP_BUY){
              if(OrderMagicNumber()==Magic) buys++; 
      } 
   } 
    }
//---- return orders volume 
   return(buys);
}



int CalculateCurrentSell(int Magic) { 
   int sells=0;
//---- 
   for(int i=0;i<OrdersTotal();i++) { 
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false ) break; 
      if(OrderSymbol()==Symbol()) { 
         if(OrderType()==OP_SELL) sells++; 
      } 
   } 
//---- return orders volume 
   return(sells);
}



//open buy position
void ApriLong(string symbol){
double StopLoss=NormalizeDouble(PendenteSell(),5);

int Ticket= OrderSend(symbol,OP_BUY,MyLotsBuy(StopLoss),NormalizeDouble(Ask,5),Slippage,0,0,"Aperto Long",MagicNumber,0,Blue);
            OrderModify(Ticket,OrderOpenPrice(),NormalizeDouble(StopLoss-(MargineSL*Point),5),0,0,Green);




}

//open short position
void ApriShort(string symbol){
double StopLoss=NormalizeDouble(PendenteBuy(),5);

int Ticket= OrderSend(symbol,OP_SELL,MyLotsSell(StopLoss),NormalizeDouble(Bid,5),Slippage,0,0,"Aperto Short",MagicNumber,0,White);
            OrderModify(Ticket,OrderOpenPrice(),NormalizeDouble(StopLoss+(MargineSL*Point),5),0,0,Green);




}

//calculate of the lots with % risk for buy order
int MyLotsBuy(double V_SL){
double StopLoss=0;
AllowedLots=(AccountFreeMargin()* Rischio_per_trade/100);
StopLoss=Ask-V_SL-MargineSL*Point;
if (Digits==2 || Digits==4)
TickValue=MarketInfo(Symbol(),MODE_TICKVALUE)/10;
else
TickValue=MarketInfo(Symbol(),MODE_TICKVALUE);
StopValue=StopLoss*TickValue;
MinLot=MarketInfo(Symbol(),MODE_MINLOT);
MaxLots=MarketInfo(Symbol(),MODE_MAXLOT);
RightLots=MathRound(AllowedLots/StopValue);
double soldi_ora = AccountBalance()/100;
MyLots = soldi_ora*(Rischio_per_trade/10);
MyLots = NormalizeDouble(MyLots/StopLoss,2);
MyLots = NormalizeDouble(MyLots/(MarketInfo(Symbol(),MODE_TICKVALUE)/100),2);       
MyLots = NormalizeDouble(MyLots/100,2);
   return(MyLots);         
            }
            
//calculate of the lots with % risk for sell order            
int MyLotsSell(double V_SL){
double StopLoss=0;
AllowedLots=(AccountFreeMargin()* Rischio_per_trade/100);
StopLoss=V_SL+MargineSL*Point-Bid;
if (Digits==2 || Digits==4)
TickValue=MarketInfo(Symbol(),MODE_TICKVALUE)/10;
else
TickValue=MarketInfo(Symbol(),MODE_TICKVALUE);
StopValue=StopLoss*TickValue;
MinLot=MarketInfo(Symbol(),MODE_MINLOT);
MaxLots=MarketInfo(Symbol(),MODE_MAXLOT);
RightLots=MathRound(AllowedLots/StopValue);
double soldi_ora = AccountBalance()/100;
MyLots = soldi_ora*(Rischio_per_trade/10);
MyLots = NormalizeDouble(MyLots/StopLoss,2);
MyLots = NormalizeDouble(MyLots/(MarketInfo(Symbol(),MODE_TICKVALUE)/100),2);       
MyLots = NormalizeDouble(MyLots/100,2);
   return(MyLots);         
            }
            

//trailing of buy order that move the stop loss at the past lower swing if it is not = to the actual orderstoploss
void TrailingBuy(double StopLoss,string symbol)
{

//---- 
   for(int i=0;i<OrdersTotal();i++) { 
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false ) break; 
      if(OrderSymbol()==symbol) { 
         if(OrderType()==OP_BUY){
              if(OrderMagicNumber()==MagicNumber)
                  if(OrderStopLoss()==NormalizeDouble(PendenteSell()-(MargineSL*Point),5))break;
                    OrderModify(OrderTicket(),OrderOpenPrice(),StopLoss-(MargineSL*Point),0,0,Green);
      } 
   } 
    }

 }
 //trailing of sell order that move the stop loss at the past lower swing if it is not = to the actual orderstoploss
 void TrailingSell(double StopLoss,string symbol)
{

//---- 
   for(int i=0;i<OrdersTotal();i++) { 
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false ) break; 
      if(OrderSymbol()==symbol) { 
         if(OrderType()==OP_SELL){
              if(OrderMagicNumber()==MagicNumber)
                  if(OrderStopLoss()== NormalizeDouble(PendenteBuy()+(MargineSL*Point),5))break;
                    OrderModify(OrderTicket(),OrderOpenPrice(),StopLoss+(MargineSL*Point),0,0,Green);
      } 
   } 
    }

 }